#include <iostream>
#include <cmath>

using namespace std;

// **************************************************
// Prima domanda
// **************************************************
struct StructPunto {
  // inserire qui corpo della struttura
  int x, y;
} TipoPunto;

struct TipoSegmento {
  // inserire qui corpo della struttura
  TipoPunto primo, secondo;
};

struct TipoLista {
  // inserire qui corpo della struttura
  TipoSegmento segmento;
  TipoLista * next;
  TipoLista(TipoSegmento s, TipoLista * n) {
    segmento = s;
    next = n;
  };
};
// **************************************************

TipoLista * ReadFile(void) {
  TipoLista * result = NULL;
  TipoSegmento s;
  char c;
  c = cin.get();
  while ( (c != EOF) && !cin.eof() ) {
    cin.unget();
    cin >> s.primo.x;
    cin >> s.primo.y;
    cin >> s.secondo.x;
    cin >> s.secondo.y;
    cin >> c;
    result = new TipoLista(s, result);
  }
  return result;
}

void PrintList(TipoLista * l) {
  while (l != NULL) {
    cout << l->segmento.primo.x << " ";
    cout << l->segmento.primo.y << " ";
    cout << l->segmento.secondo.x << " ";
    cout << l->segmento.secondo.y << endl;
    l = l->next;
  }
}

void PrintMaggiore(TipoSegmento s, double l) {
  cout << "Segmento piu' lungo: ";
  cout << s.primo.x << " ";
  cout << s.primo.y << " ";
  cout << s.secondo.x << " ";
  cout << s.secondo.y << endl;
  cout << "Lunghezza = " << l << endl;
}

// **************************************************
// terza domanda
// **************************************************
TipoLista * TogliParalleli(TipoLista * l) {
  // inserire qui corpo della funzione
  TipoLista * result = NULL;
  while(l != NULL) {
    if (l->segmento.primo.x != l->segmento.secondo.x &&
        l->segmento.primo.y != l->segmento.secondo.y) {
      result = new TipoLista(l->segmento, result);
    }
    l = l->next;
  }
  return result;
}
// **************************************************

// **************************************************
// terza domanda
// **************************************************
double Lunghezza(TipoSegmento s) {
  double result = 0.0;
  int diffx = s.primo.x - s.secondo.x;
  int diffy = s.primo.y - s.secondo.y;
  result = sqrt(diffx*diffx + diffy*diffy);
  return result;
}

void LunghezzaMaggiore(TipoLista * l, TipoSegmento &s, double & ln) {
  // inserire qui corpo della funzione
  if (l == NULL) {
    cerr << "ERRORE: lista vuota" << endl;
    exit(1);
  }
  else {
    s = l->segmento;
    ln = Lunghezza(s);
    l = l->next;
    while (l != NULL) {
      double lnt = Lunghezza(l->segmento);
      if (lnt > ln) {
        ln = lnt;
        s = l->segmento;
      }
      l = l->next;
    }
  }
}
// **************************************************

// **************************************************
// quarta domanda
// **************************************************
void CancellaLista(TipoLista * & l) {
  // inserire qui corpo della funzione
  while(l != NULL) {
    TipoLista * l1 = l;
    l = l->next;
    delete l1;
  }
}
// **************************************************

int main(int argc, char *argv[])
{
  TipoLista * lista = NULL;
  TipoLista * lista1 = NULL;
  TipoSegmento s;
  double lenght;

  lista = ReadFile();

  // Domanda 2:
  // scommentare le quattro righe di codice seguente
  lista1 = TogliParalleli(lista);
  cout << "Lista segmenti non paralleli:" << endl;
  PrintList(lista1);

  // Domanda 4: 
  CancellaLista(lista);

  // Domanda 3: 
  // Scommentare le tre righe di codice seguente
  LunghezzaMaggiore(lista1, s, lenght);
  PrintMaggiore(s, lenght);

  // Domanda 4: 
  CancellaLista(lista1);
}



